var STORAGE_EVENTS = new JsonStorage('events');
var STORAGE_FAVS = new JsonStorage('favorites');
var WS_GET_EVENTS = 'backend/get.php';
var WS_ADD_EVENTS = 'backend/add.php';
var TEMPLATE_EVENT;
var TEMPLATE_FAV;

$(function (){
  menuHandler();
  $(window).trigger("popstate");
  takeItOffline();
  loadTemplates();
  clearMessages();
  $("#btn_submit_event").on("click",addRemoteEntry);
  $("#page_list").on("click",".btn_add",addFavEvent);
  $("#page_fav").on("click",".btn_remove",deleteFavEvent);
  $("#page_list").on("EVENTS_DOM_REFRESH",refreshEventDom);
  $("#page_list").trigger("EVENTS_DOM_REFRESH");
  $("#page_fav").on("FAVS_DOM_REFRESH",refreshFavDom);
  $("#page_fav").trigger("FAVS_DOM_REFRESH");
  $("#page_list").on("EVENT_SUCCESSFULLY_ADDED",getRemoteEvents);
  getRemoteEvents();
  $(".btn_add").on("click",addFavEvent);
  $("nav.main").on("click","a",navColorHandle);
  $("nav.main a.disabled").on("click", function(){
    event.preventDefault();
  });
});

function menuHandler() {
  //Changement de page
  $(window).on("popstate", function(e){
    var idPage = location.hash;
    idPage = idPage.substring(1);
    if($("#page_" + idPage).length == 0){
      switchPage("list");
    }else{
      switchPage(idPage);
    }
  });
}

function switchPage(idPage){
  $(".page").hide();
  $("#page_"+idPage).show();
  clearMessages();

}

function takeItOffline() {
  $(window).on("offline online", goOfflineOnline);
  $("body").on("offline online", goOfflineOnline);
  if (navigator.onLine){
    goOfflineOnline();
  }
}

function goOfflineOnline(){
  $("#onlineStatus").toggleClass('online').toggleClass('offline');
  $('[href="#add"]').toggleClass('disabled');
}

function navColorHandle(){
  $("nav.main a").removeClass("activ");
  $(this).toggleClass("activ");
}

function getRemoteEvents(){
  if($("#onlineStatus").hasClass("online")){
  STORAGE_EVENTS.clear();
  $.getJSON(WS_GET_EVENTS,function(results){
    $.each(results, function(i,entry){
      STORAGE_EVENTS.addItem(
        {
          title:entry.title,
          date:entry.date,
          place:entry.place
        }
      );
    });
  $("#page_list").trigger("EVENTS_DOM_REFRESH");
  });
  }
}
function refreshEventDom(){
  $("#page_list").empty();
  var entries = STORAGE_EVENTS.toArray();
  $.each(entries, function(index,value){
    var title = value.item.title;
    var date = value.item.date;
    var place = value.item.place;
    var id = value.key;
    var template = TEMPLATE_EVENT.clone();
    $("h1",template).text(title);
    $("time",template).text(date);
    $("span",template).text(place);
    $("button",template).attr('id',id);
    template.appendTo("#page_list");
  });
}

function refreshFavDom(){
  $("#page_fav").empty();
  var entries = STORAGE_FAVS.toArray();
  $.each(entries, function(index,value){
    var title = value.item.title;
    var date = value.item.date;
    var place = value.item.place;
    var id = value.key;
    var template = TEMPLATE_FAV.clone();
    $("h1",template).text(title);
    $("time",template).text(date);
    $("span",template).text(place);
    $("button",template).attr('id',id);
    template.appendTo("#page_fav");
  });
}

function addFavEvent(){
  var item = STORAGE_EVENTS.getItem($(this).attr('id'));
  STORAGE_FAVS.addItem(item);
  $("#page_fav").trigger("FAVS_DOM_REFRESH");
}

function deleteFavEvent(){
  var item = $(this).attr('id');
  STORAGE_FAVS.removeItem(item);
  $("#page_fav").trigger("FAVS_DOM_REFRESH");
}
function loadTemplates(){
  TEMPLATE_FAV = $("article.template_fav").clone().removeClass("template");
  TEMPLATE_EVENT = $("article.template_event").clone().removeClass("template");
}

function addRemoteEntry(){
  clearMessages();
  var title = $("#eventTitle").val();
  var date = $("#eventDate").val();
  var place = $("#eventPlace").val();
  $.post(WS_ADD_EVENTS,{title: title,date:date,place:place},function(data){
    if(data.status == 'success'){
      $("#eventTitle").val('');
      $("#eventDate").val('');
      $("#eventPlace").val('');
      showSuccessMessage();
      $("#page_list").trigger("EVENT_SUCCESSFULLY_ADDED");
    }else if(data.status == 'fail'){
      showErrorMessage();
    }else{
      showErrorMessage();
    }
  });
}

function clearMessages(){
  $("#eventAddSuccess").text('');
  $("#eventAddError").text('');
}

function showErrorMessage(){
  $("#eventAddError").text($("#eventAddError").attr('data-msg'));
}

function showSuccessMessage(){
  $("#eventAddSuccess").text($("#eventAddSuccess").attr('data-msg'));
}
